Unit rsc1r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure rsc1r(var SX :Array of Real; var SY :Array of Real;
                var SXY1 :Array of Real; var SXY2 :Array of Real;
                NC :Integer; DT :Real; var CX :Array of Real;
                var CY :Array of Real; var CXY :Array of Real;
                var R :Array of Real);

implementation

procedure rsc1r(var SX :Array of Real; var SY :Array of Real;
                var SXY1 :Array of Real; var SXY2 :Array of Real;
                NC :Integer; DT :Real; var CX :Array of Real;
                var CY :Array of Real; var CXY :Array of Real;
                var R :Array of Real);
var
I,IS_,N,N2 :Integer;
G,V,Q,P :Real;
label
_1,_2,_3,_4;
begin
N := Trunc( 2*(NC-1) );
G := 1.0/(2.0*DT*(N));
V := G*2.0;
CXY[0] := SX[0];
R[0] := SY[0];
for I:=2 to NC do
 begin
  IS_ := N+2-I;
  Q := SX[I-1];
  CXY[I-1] := Q;
  CXY[IS_-1] := Q;
  Q := SY[I-1];
  R[I-1] := Q;
_1:
  R[IS_-1] := Q;
 end;
P := -1.0;
FTF1C(CXY,R,N,1,1,P);
CXY[N+0] := CXY[0];
R[N+0] := R[0];
for I:=1 to NC do
 begin
  IS_ := N+2-I;
  CX[I-1] := (CXY[I-1]+CXY[IS_-1])*G;
_2:
  CY[I-1] := (R[I-1]+R[IS_-1])*G;
 end;
CXY[0] := SXY1[0];
R[0] := 0.0;
CXY[NC-1] := SXY1[NC-1];
R[NC-1] := 0.0;
N2 := NC-1;
for I:=2 to N2 do
 begin
  IS_ := N+2-I;
  Q := SXY1[I-1];
  CXY[I-1] := Q;
  CXY[IS_-1] := Q;
  Q := SXY2[I-1];
  R[I-1] := Q;
_3:
  R[IS_-1] := -Q;
 end;
FTF1C(CXY,R,N,1,1,P);
for I:=1 to N do
 begin
_4:
  CXY[I-1] := CXY[I-1]*V;
 end;
end;

end.
